%define extra 1
%define enable_extrusion 1
%define disable_inappropriate 1

%{?_with_extra: %{expand: %%global extra 1}}
%{?_without_extra: %{expand: %%global extra 0}}
%{?_with_extrusion: %{expand: %%global enable_extrusion 1}}
%{?_without_extrusion: %{expand: %%global enable_extrusion 0}}
%{?_with_inappropriate: %{expand: %%global disable_inappropriate 0}}
%{?_without_inappropriate: %{expand: %%global disable_inappropriate 1}}


Summary:	A set of X Window System screensavers
Summary(de):	Automatischer Bildschirmschoner für X
Name:		xscreensaver
Version:	5.37
Release:	%mkrel 2
License:	BSD
Group:		Graphical desktop/Other
URL:		http://www.jwz.org/xscreensaver/
Source0:	http://www.jwz.org/xscreensaver/%{name}-%{version}.tar.xz
Source1:	xscreensaver-capplet.png
Source2:	xscreensaver-properties.desktop
Source3:	xscreensaver-e17.desktop
Source4:    xscreensaver.pamd
Patch9:		xscreensaver-5.32-defaultconfig.patch
Patch10:	xscreensaver-4.23-root.patch
Patch11:	xscreensaver-5.09-noGL.patch
Patch19:	xscreensaver-5.00-inappropriate.patch
Patch21:	xscreensaver-5.35-disable-too-old-warning.patch
Requires:	xscreensaver-common = %{version}-%{release}
Requires:   xscreensaver-base = %{version}-%{release}
Requires:	xdg-utils
BuildRequires:	bc
BuildRequires:	libjpeg-devel
BuildRequires:	pam-devel
BuildRequires:	xpm-devel
BuildRequires:	libglade2.0-devel
BuildRequires:	imagemagick
BuildRequires:	freeglut-devel
BuildRequires:	libx11-devel
BuildRequires:	libxext-devel
BuildRequires:	libxi-devel
BuildRequires:	libxinerama-devel
BuildRequires:	libxmu-devel
BuildRequires:	libxrandr-devel
BuildRequires:	libxt-devel
BuildRequires:	%{_lib}xxf86misc-devel
BuildRequires:	libxxf86vm-devel
BuildRequires:	makedepend
BuildRequires:	intltool
BuildRequires:	libpthread-stubs
%if %enable_extrusion
BuildRequires:	libgle-devel
%endif
BuildRequires:	desktop-file-utils
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The xscreensaver package contains a variety of screensavers for your
mind-numbing, ambition-eroding, time-wasting, hypnotized viewing
pleasure.

Install the xscreensaver package if you need screensavers for use with
the X Window System.
#german
%description -l de
Der Sinn von xscreensaver ist es, hübsche Bilder auf Ihrem Monitor anzuzeigen, 
wenn er nicht in Benutzung ist. Dies geschieht nach der Philosophie, dass 
unbenutzte Monitore immer etwas Interessantes tun sollten, ganz so wie sie es 
in Filmen tun. Der Vorteil, den dieses Programm gegenüber der Kombination von 
xlock und xautolock hat, ist die Leichtigkeit mit der neue graphische Hacks 
installiert werden können: Sie müssen dieses Programm nicht neu kompilieren, 
um neue Display-Modi hinzuzufügen; Sie ändern einfach nur einige Hilfseinstellungen. 

Jedes beliebige Programm, das auf solche Weise aufgerufen werden kann, dass es 
im Hauptfenster des Schirms zeichnet, kann nun ohne Änderungen als Bildschirmschoner 
benutzt werden. Die Programme, die als Bildschirmschoner ausgeführt werden, brauchen 
selbst kein spezielles Wissen darüber zu haben, was es heißt, ein Bildschirmschoner 
zu sein. 


%package base
Summary:	A set of screensavers
Summary(de):	Verschiedene Bildschirmschoner
Group:		Graphical desktop/Other
Requires:	xscreensaver-common = %{version}-%{release}
Conflicts:	xscreensaver < 5.00-2
Requires:	words

%description base
Various screensavers used by Xscreensaver.
#german
%description base -l de
Verschiedene Bildschirmschoner verwendet von Xscreensaver.

%package common
Summary:	Utilities used by xscreensaver screensavers
Summary(de):	Verwendete Programme für xscreensaver 
Group:		Graphical desktop/Other
Conflicts:	xscreensaver < 5.00-2
Obsoletes:	xscreensaver-utils
Provides:	xscreensaver-utils
Requires:	chbg

%description common
Utilities used by xscreensaver screensavers.
#german
%description common -l de
Programme, verwendet von xscreensaver Bildschirmschonern. 

%package gl
Summary:	A set of GL screensavers
Summary(de):	GL (Mesa) Sammlung für xscreensaver
Group:		Graphical desktop/Other
Requires:	xscreensaver-common = %{version}-%{release}
Requires(post):	xscreensaver-common = %{version}-%{release}
Requires(postun):	xscreensaver-common = %{version}-%{release}

%description gl
The xscreensaver-gl package contains even more screensavers for your
mind-numbing, ambition-eroding, time-wasting, hypnotized viewing
pleasure. These screensavers require OpenGL or Mesa support.

Install the xscreensaver-gl package if you need more screensavers for
use with the X Window System and you have OpenGL or Mesa installed.
#german
%description gl -l de
Dies sind einige zusätzliche Themen (Hacks) für xscreensaver, welche 
die OpenGL-kompatible Bibliothek Mesa verwenden. Diese sind in einem 
Extrapaket verfügbar, so dass das Basispaket nicht von Mesa abhängig ist. 

Zusätzlich fungieren diese Hacks prima als GL-Demos für Leute, die 
hardwarebeschleunigtes 3D mit XFree86 4.x ausprobieren wollen. 

%if %extra
%package matrix
Summary:	The Matrix screensavers
Summary(de):	Der Matrix Bildschirmschoner 
Group:		Graphical desktop/Other
Requires:	xscreensaver-common = %{version}-%{release}

%description matrix
The xscreensaver-matrix package contains two screensavers for
xscreensaver based on the movie The Matrix. 
#german
%description matrix -l de
Das xscreensaver-matrix Paket enthält zwei Bildschirmschoner 
für Bildschirmschoner, basierend auf dem Film Die Matrix. 

%endif

%if %enable_extrusion
%package extrusion
Summary:	OpenGL screensaver
Summary(de):	OpenGL Bildschirmschoner
Group:		Graphical desktop/Other
Requires:	xscreensaver-common = %{version}-%{release}

%description extrusion
The xscreensaver-extrusion package contains the extrusion
screensaversfor your mind-numbing, ambition-eroding, time-wasting,
hypnotized viewing pleasure. This screensaver requires OpenGL or Mesa
support.

This screensaver is in a separate package, because it is the only
application for the PCLOS distribution which requires the GLE
extrusion library.
#german
%description extrusion -l de
Das xscreensaver-extrusion Paket enthält die Extrusions Bildschirmschoner, 
wenn es todlangweilig ist, um den Ehrgeiz zu untergraben, zum Zeitvertreib, 
und zur Freude des hypnotischen Betrachtens. 
Diese Bildschirmschoner benötigen OpenGL oder Mesa Unterstützung. Diese 
Bildschirmschoner sind in einem extra Paket, da es nur Anwendungen für die 
Mandirva Linux Distributionen sind, die die GLE extrusion Bibliothek benötigen. 
%endif

%prep
%setup -q
%patch9 -p0 -b .defaultconfig
%patch10 -p1 -b .root
%patch11 -p1 -b .noGL
%if %{disable_inappropriate}
%patch19 -p1 -b .inappropriate
%endif
%patch21 -p1

%build
autoreconf -fiv
%configure2_5x \
    --enable-locking \
    --enable-root-passwd \
    --with-browser=xdg-open \
    --with-dpms-ext \
    --with-xinerama-ext \
    --with-xf86vmode-ext \
    --with-xf86gamma-ext \
    --with-randr-ext \
    --with-proc-interrupts \
    --with-login-manager=gdmflexiserver \
    --with-pixbuf \
    --with-xpm \
    --with-jpeg \
    --with-xshm-ext \
    --with-xdbe-ext \
    --with-gtk \
    --with-pam \
    --with-gl \
    --with-image-directory="%{_datadir}/mdk/screensaver" \
    --without-motif \
    --without-readdisplay \
    --without-setuid-hacks \
    --without-shadow \
    --without-kerberos \
%if %enable_extrusion
    --with-gle
%else
    --without-gle
%endif

make depend
%make

%install
rm -rf %{buildroot} gl-extras.files base.files %{name}.lang
mkdir -p %{buildroot}%{_sysconfdir}/X11/app-defaults/
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_mandir}/man6
mkdir -p %{buildroot}%{_sysconfdir}/pam.d
mkdir -p %{buildroot}%{_libexecdir}/xscreensaver

make install_prefix=%{buildroot} bindir=%{_bindir} \
 KDEDIR=%{_prefix} GNOME_BINDIR=%{_bindir}  GNOME_DATADIR=%{_datadir} \
 mandir=%{_mandir} AD_DIR=%{_sysconfdir}/X11/app-defaults/ \
 gnulocaledir=%{_datadir}/locale install

cat<<EOF >README.GL
The xscreensaver-gl package contains even more screensavers for your
mind-numbing, ambition-eroding, time-wasting, hypnotized viewing
pleasure. These screensavers require OpenGL or Mesa support.

Install the xscreensaver-gl package if you need more screensavers for
use with the X Window System and you have OpenGL or Mesa installed.
EOF

mkdir -p %{buildroot}%{_datadir}/applications
install -m 0644 %SOURCE2 %{buildroot}%{_datadir}/applications/xscreensaver-properties.desktop
install -m 0644 %SOURCE3 %{buildroot}%{_datadir}/applications/xscreensaver-e17.desktop

#icons
mkdir -p %{buildroot}%{_datadir}/pixmaps
mkdir -p %{buildroot}%{_iconsdir}/hicolor/{16x16,32x32,48x48}/apps
cp %{SOURCE1}  %{buildroot}%{_datadir}/pixmaps
convert -scale 16x16 %{SOURCE1} %{buildroot}%{_iconsdir}/hicolor/16x16/apps/%{name}.png
convert -scale 32x32 %{SOURCE1} %{buildroot}%{_iconsdir}/hicolor/32x32/apps/%{name}.png
ln -s %{_datadir}/pixmaps/xscreensaver-capplet.png %{buildroot}%{_iconsdir}/hicolor/48x48/apps/%{name}.png

#remove unpackaged files
rm -f %{buildroot}%{_datadir}/xscreensaver/config/xjack.xml
rm -f %{buildroot}%{_mandir}/man6/xjack.6  
rm -f  %{buildroot}%{_libexecdir}/xscreensaver/xjack

%if ! %extra
rm -rf %{buildroot}%{_libexecdir}/xscreensaver/*matrix
rm -rf %{buildroot}%{_mandir}/man6/*matrix*
rm -rf %{buildroot}%{_datadir}/xscreensaver/config/*matrix*
%endif
%if ! %enable_extrusion
rm -f %{buildroot}%{_datadir}/xscreensaver/config/extrusion.xml
rm -f %{buildroot}%{_mandir}/man6/extrusion.6
%endif

install -m 0644 %SOURCE4 %{buildroot}/etc/pam.d/xscreensaver

#
list_files() {
  make -s install_prefix=%{buildroot} mandir=%{_mandir}/ \
  bindir=%{_bindir} INSTALL=true "$@"	\
   | sed -n -e 's@.* \(/[^ ]*\)$@\1@p'				\
   | sed    -e "s@^%{buildroot}@@"				\
	    -e "s@/[a-z][a-z]*/\.\./@/@"			\
   | sed    -e 's@\(.*/man/.*\)@\1\*@'				\
   | sed    -e 's@\(.*/app-defaults/\)@%config \1@'		\
	    -e 's@\(.*/pam\.d/\)@%config(missingok) \1@'	\
   | sort
}

# Generate three lists of files for the three packages.
#
dd=%{_builddir}/%{name}-%{version}
( cd hacks/glx ; list_files install > $dd/gl-extras.files)
( cd hacks     ; list_files install > $dd/base.files)

perl -pi -e "s/.*(gdadou|xjack|matrix|extrusion).*//" gl-extras.files base.files

%find_lang %{name}

%clean
rm -rf %{buildroot}
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%pre
rm -f /etc/pam.d/xscreensaver

%post 
%{update_menus}
%update_icon_cache hicolor

%postun
%{clean_menus}
%clean_icon_cache hicolor

%post gl
sed -i -e 's/\A-\s+GL:/ GL:/' %{_sysconfdir}/X11/app-defaults/XScreenSaver

%postun gl
sed -i -e '/\A\s*GL:/ and print "- $_" or print "$_"' %{_sysconfdir}/X11/app-defaults/XScreenSaver


%files -f %{name}.lang
%defattr(-,root,root)
%{_sysconfdir}/pam.d/xscreensaver
%doc README
%{_mandir}/man1/xscreensaver-command.1*
%{_mandir}/man1/xscreensaver-demo.1*
%{_mandir}/man1/xscreensaver.1*
%attr(755,root,chkpwd) %{_bindir}/xscreensaver
%{_bindir}/xscreensaver-command
%{_bindir}/xscreensaver-demo
%dir %{_datadir}/xscreensaver
%{_datadir}/xscreensaver/glade
%{_datadir}/applications/*
%{_datadir}/pixmaps/*
#%{_datadir}/xscreensaver/config/gdadou.xml
%{_iconsdir}/hicolor/*/apps/*.png

%files common 
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/X11/app-defaults/*
%dir %{_libexecdir}/%{name}
%{_bindir}/xscreensaver-getimage
%{_bindir}/xscreensaver-getimage-file
%{_bindir}/xscreensaver-getimage-video
%{_bindir}/xscreensaver-text
%{_mandir}/man1/xscreensaver-getimage*
%{_mandir}/man1/xscreensaver-text.1*
%dir %{_datadir}/%{name}/config
%{_datadir}/%{name}/config/README

%files base -f base.files
%defattr(-,root,root)
#%exclude %{_datadir}/xscreensaver/config/gdadou.xml

%files gl -f gl-extras.files
%defattr(-,root,root)
%doc README.GL

%if %enable_extrusion
%files extrusion
%defattr(-,root,root)
%doc README.GL
%{_datadir}/xscreensaver/config/extrusion.xml
%{_mandir}/man6/extrusion.6*  
%{_libexecdir}/xscreensaver/extrusion
%endif

%if %extra
%files matrix
%defattr(-,root,root)
%doc README.GL
%{_mandir}/man6/xmatrix.6*
%{_mandir}/man6/glmatrix.6*
%{_datadir}/xscreensaver/config/glmatrix.xml
%{_datadir}/xscreensaver/config/xmatrix.xml
%{_libexecdir}/xscreensaver/xmatrix
%{_libexecdir}/xscreensaver/glmatrix
%endif


%changelog
* Fri Sep 22 2017 bb1 <bb2> - 5.37-2pclos2017
- fix xscreensaver pamd.d

* Mon Jul 17 2017 bb2 <bb2> - 5.37-1pclos2017
- new version

* Sun Jul 16 2017 bb2 <bb2> - 5.36-2pclos2017
- rebuild against updates

* Mon Oct 31 2016 ghostbunny <ghostbunny at gmx dot de> 5.36-1pclos2016
- 5.36


